#property copyright "Optimized and Improved Version by tuxTrader"
#property link      "https://www.forexfactory.com/tuxtrader"
//+------------------------------------------------------------------+
//|   AutoPivotIndicator.mq4          ver 4.02           by Habeeb   |
//|                                                                  |
//|          This version solves the Sunday Bar problem.             |
//| Ver4 calculated daily pivots incorrectly when Use_Sunday_Data    |
//|        was set to "False".  Fixed in this version.               |
//+------------------------------------------------------------------+
//  some display upgrades added by Aaragorn 11/27/07


//+---------------------------------------------------------------------+
//  CHANGES by tuxTrader@ForexFactory :                                 |
//                                                                      |
//  Added "Labels_Adjust" & "Lines_Move_to_Right" settings _ 12/22/2019 |
//  Added "Lines_Shift" option.                            _ 12/23/2019 |
//  Minor bug fixes & Code Optimization                    _ 12/23/2019 |
//  Optimized "Lines_Shift" option to shift lines to right _ 12/29/2019 |
//+---------------------------------------------------------------------+



#property indicator_chart_window

   extern bool Use_Sunday_Data     = true;
   extern bool Daily               = true;
   extern bool Daily_SR_Levels     = true;
   extern bool Weekly              = false;
   extern bool Weekly_SR_Levels    = false;
   extern bool Monthly             = false;
   extern bool Monthly_SR_Levels   = false;
   extern int  Labels_Adjust       = 10;
   extern bool Lines_Move_to_Right = false;
   extern int  Lines_Shift         = 0;



   double YesterdayHigh;
   double YesterdayLow;
   double YesterdayClose;
   double Day_Price[][6];
   double Pivot,S1,S2,S3,R1,R2,R3;
      
   double WeekHigh;
   double WeekLow;
   double WeekClose;
   double Weekly_Price[][6];
   double WeekPivot,WS1,WS2,WS3,WR1,WR2,WR3;
   
   double MonthHigh;
   double MonthLow;
   double MonthClose;
   double Month_Price[][6];
   double MonthPivot,MS1,MS2,MS3,MR1,MR2,MR3;

   datetime endTime=0, startTime=0;
   bool     PlotFactor=false;

int init()
  {
   return(0);
  }

//-------------------------------------------------------- 


void OnDeinit(const int reason)
{
   switch(reason)
   {
      case REASON_CHARTCHANGE : break;
      case REASON_CHARTCLOSE  : break;
      case REASON_RECOMPILE   : break;
      case REASON_CLOSE       : break;
      default                 :
      {
        DeleteObjectsByString("Line",0);
        DeleteObjectsByString("Label",0);
      }
   }  
   WindowRedraw();
}



//--------------------------------------------------------- 



int start()
{

ArrayCopyRates(Day_Price,(Symbol()), 1440);



   YesterdayHigh  = Day_Price[1][3];
   YesterdayLow   = Day_Price[1][2];
   YesterdayClose = Day_Price[1][4];
   
   Pivot = ((YesterdayHigh + YesterdayLow + YesterdayClose)/3);

   R1 = (2*Pivot)-YesterdayLow;
   S1 = (2*Pivot)-YesterdayHigh;

   R2 = Pivot+(R1-S1);
   S2 = Pivot-(R1-S1);
   
   R3 = (YesterdayHigh + (2*(Pivot-YesterdayLow)));
   S3 = (YesterdayLow - (2*(YesterdayHigh-Pivot)));  
  
  
if (Use_Sunday_Data == false)
 {   
   while (DayOfWeek() == 1)
      {  
       YesterdayHigh  = Day_Price[2][3];
       YesterdayLow   = Day_Price[2][2];
       YesterdayClose = Day_Price[2][4];
   
       Pivot = ((YesterdayHigh + YesterdayLow + YesterdayClose)/3);

       R1 = (2*Pivot)-YesterdayLow;
       S1 = (2*Pivot)-YesterdayHigh;

       R2 = Pivot+(R1-S1);
       S2 = Pivot-(R1-S1);
   
       R3 = (YesterdayHigh + (2*(Pivot-YesterdayLow)));
       S3 = (YesterdayLow - (2*(YesterdayHigh-Pivot)));
       break;
      }
 }


//--------------------------------------------------------
//--------------------------------------------------------


ArrayCopyRates(Weekly_Price, Symbol(), 10080);

WeekHigh  = Weekly_Price[1][3];
WeekLow   = Weekly_Price[1][2];
WeekClose = Weekly_Price[1][4];

WeekPivot = ((WeekHigh + WeekLow + WeekClose)/3);

      WR1 = (2*WeekPivot)-WeekLow;
      WS1 = (2*WeekPivot)-WeekHigh;

      WR2 = WeekPivot+(WR1-WS1);
      WS2 = WeekPivot-(WR1-WS1);

      WS3 = (WeekLow - (2*(WeekHigh-WeekPivot)));
      WR3 = (WeekHigh + (2*(WeekPivot-WeekLow)));

//--------------------------------------------------------
//--------------------------------------------------------


ArrayCopyRates(Month_Price, Symbol(), 43200);

MonthHigh  = Month_Price[1][3];
MonthLow   = Month_Price[1][2];
MonthClose = Month_Price[1][4];

MonthPivot = ((MonthHigh + MonthLow + MonthClose)/3);

      MR1 = (2*MonthPivot)-MonthLow;
      MS1 = (2*MonthPivot)-MonthHigh;

      MR2 = MonthPivot+(MR1-MS1);
      MS2 = MonthPivot-(MR1-MS1);

      MS3 = (MonthLow - (2*(MonthHigh-MonthPivot)));
      MR3 = (MonthHigh + (2*(MonthPivot-MonthLow)));


//--------------------------------------------------------
//--------------------------------------------------------


if (Daily==true)
{
 DrawLine("PivotLine","PivotLabel","DP",Pivot,Magenta);

 if (Daily_SR_Levels==true)
 {
   DrawLine("R1_Line","R1_Label","DR1",R1,Red);
   DrawLine("R2_Line","R2_Label","DR2",R2,Red);
   DrawLine("R3_Line","R3_Label","DR3",R3,Red);

   DrawLine("S1_Line","S1_Label","DS1",S1,LimeGreen);
   DrawLine("S2_Line","S2_Label","DS2",S2,LimeGreen);
   DrawLine("S3_Line","S3_Label","DS3",S3,LimeGreen);
 }
}

//---------------------------------------------------------
//---------------------------------------------------------
//---------------------------------------------------------

if (Weekly==true)
{
 DrawLine("WeekPivotLine","WeekPivotLabel","WP",WeekPivot,Aqua);

 if (Weekly_SR_Levels==true)
 {
   DrawLine("WR1_Line","WR1_Label","WR1",WR1,Yellow);
   DrawLine("WR2_Line","WR2_Label","WR2",WR2,Yellow);
   DrawLine("WR3_Line","WR3_Label","WR3",WR3,Yellow);

   DrawLine("WS1_Line","WS1_Label","WS1",WS1,SteelBlue);
   DrawLine("WS2_Line","WS2_Label","WS2",WS2,SteelBlue);
   DrawLine("WS3_Line","WS3_Label","WS3",WS3,SteelBlue);
 }
}

//---------------------------------------------------------
//---------------------------------------------------------
//---------------------------------------------------------

if (Monthly==true)
{
 DrawLine("MonthPivotLine","MonthPivotLabel","MP",MonthPivot,White);

 if (Monthly_SR_Levels==true)
 {
   DrawLine("MR1_Line","MR1_Label","MR1",MR1,Blue);
   DrawLine("MR2_Line","MR2_Label","MR2",MR2,Blue);
   DrawLine("MR3_Line","MR3_Label","MR3",MR3,Blue);

   DrawLine("MS1_Line","MS1_Label","MS1",MS1,Silver);
   DrawLine("MS2_Line","MS2_Label","MS2",MS2,Silver);
   DrawLine("MS3_Line","MS3_Label","MS3",MS3,Silver);
 }
}

   return(0);
}



//---------------------------------------------------------
//---------------------------------------------------------
void DrawLine(string LineName, string LabelName, string LabelText, double Price, color COLOR)
{
   startTime=0;  endTime=0;
   if(Lines_Move_to_Right)  { startTime = Time[0]+(Period()*60*Lines_Shift);  endTime = startTime + (Period()*60*1);                 PlotFactor=true; }
   else                     { startTime = iTime(Symbol(),PERIOD_D1,-1);       endTime = iTime(Symbol(),PERIOD_D1,0)+(PERIOD_D1*60);  PlotFactor=true; }

  ObjectCreate(LineName, OBJ_TREND,0,startTime,Price,endTime,Price);
  ObjectSet(LineName, OBJPROP_TIME1, startTime);
  ObjectSet(LineName, OBJPROP_TIME2, endTime);
  ObjectSet(LineName, OBJPROP_COLOR, COLOR);
  ObjectSet(LineName, OBJPROP_STYLE, STYLE_DASH);
  ObjectSet(LineName, OBJPROP_RAY,   PlotFactor);
  ObjectSet(LineName, OBJPROP_SELECTABLE, false);
  ObjectSet(LineName, OBJPROP_SELECTED, false);  
  ObjectSet(LineName, OBJPROP_HIDDEN, true);
  ObjectMove(LineName, 1, endTime, Price);
  ObjectMove(LineName, 0, startTime, Price);

  if(ObjectFind(LabelName) != 0)
  {
   ObjectCreate(LabelName, OBJ_TEXT, 0, Time[0]+(Period()*60*Labels_Adjust), Price);
   ObjectSetText(LabelName, LabelText, 6, "Arial Black", COLOR);
  }
  else
  {
   ObjectMove(LabelName, 0, Time[0]+(Period()*60*Labels_Adjust), Price);
   ObjectMove(LineName, 0, startTime,Price);
  }

  ObjectsRedraw();
  WindowRedraw();
}



//---------------------------------------------------------
//---------------------------------------------------------
void DeleteObjectsByString(string Search,int SubWin, int ObjectType=-1) {
   int TotalObject = ObjectsTotal(0,SubWin,-1);
   for (int i = TotalObject; i >= 0 ; i--)
   {
      if (StringFind(ObjectName(0, i, SubWin, ObjectType), Search, 0) > -1)
      {
         ObjectDelete(0,ObjectName(0,i,SubWin,-1));
      }      
   }
}